fn id<T>(x: T) -> T {
    x
}

fn compose<A, B, C, F, G>(f: F, g: G) -> impl Fn(A) -> C
where
    F: Fn(A) -> B,
    G: Fn(B) -> C,
{
    move |x: A| g(f(x))
}

fn inc(x: u32) -> u32 {
    x + 1
}

fn main() {
    assert!(compose(id, inc)(2) == compose(inc, id)(2));
}
